#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <signal.h>
#include <fstream.h>
#include <iostream.h>

#include <qpainter.h>

#include "qtcamera.h"
//unsigned short ycbcr422[76800];
unsigned short rgb[76800];

//unsigned short savecount;

int dev_camera;
unsigned short continue_capture;
//unsigned short cbfirst;
pid_t id;

extern qtcamera *mycamera;

void framesignal(int sig)
{
	read(dev_camera,rgb,153600);
	mycamera->showPic();
}

qtcamera::qtcamera()
{
	
	setCaption("Project : Qt/E camera image capture");	
	resize(240, 320);

	languageChange();

	//variable initialization
	//CMOSImage create
	if(!CMOSImage.create(240,320,16,0,QImage::BigEndian)){
		printf("\nImage create error!!!");
		printf("\nImage create error!!!");
	}
	
	//CMOSRect init
	CMOSRect.setRect(0,0,240,320);
	//initial open()
	dev_camera = open("/dev/camera", O_RDWR);
	if(dev_camera < 0) {
		printf("application : camera driver open fails!\n");
		exit(0);
	}
	
	(void)signal(SIGUSR2,framesignal);
	id = getpid();
	continue_capture=1;
	write(dev_camera,&id,4);
	
/*	continue_capture=0;
	savecount=0;
	cbfirst=1;
//	sleep(5);
*/	

//	id = getpid();
//	write(dev_camera,&id,4);
}

qtcamera::~qtcamera()
{
    // no need to delete child widgets, Qt does it all for us
	continue_capture=0;
	close(dev_camera);
}


void qtcamera::showPic()
{
	int i,j;
	memcpy(CMOSImage.bits(), rgb, 153600); 
  	repaint(false);

	// ̹ 
	DATAImage = CMOSImage.copy();
	DATAImage.save("/root/image0.jpg","JPEG");

  	if(continue_capture) write(dev_camera,&id,4);
}

void qtcamera::languageChange()
{
}
/*
void qtcamera::onecapture()
{
	continue_capture=0;	
	write(dev_camera,&id,4);
}

void qtcamera::continuecapture()
{
	continue_capture=1;	
	write(dev_camera,&id,4);
}
*/

void qtcamera::paintEvent(QPaintEvent*)
{
	QPainter p(this);
	p.drawImage(0,0,CMOSImage,0);
}
